=== debian/changelog ===
opencpn (5.6.2+dfsg-1~bpo11+3) bullseye-backports; urgency=medium

  *  Add patch for long delays when exiting. Closes: #1032296

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 03 Mar 2023 09:19:40 +0100

opencpn (5.6.2+dfsg-1~bpo11+2) bullseye-backports; urgency=medium

  * Add patch fur unusable buildd version. Closes: #1010860

 -- Alec Leamas <leamas.alec@gmail.com>  Wed, 11 May 2022 21:06:26 +0200

opencpn (5.6.2+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Initial bullseye backport of 5.6.2+dfsg-1

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 26 Apr 2022 15:06:54 +0200

opencpn (5.6.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove upstream debian packaging in source tarball.
  * Add patch for wrong desktop filename (tracker.debian.org warning).
  * d/rules: Add explicit CMAKE_BUILD_TYPE setting (upstream discussion
    in https://github.com/OpenCPN/OpenCPN/issues/2612)
  * d/watch: dfsg1 -> dfsg (lintian warning)
  * d/control: Add missing -b branch to Vcs-Git:
  * d/control: Make opencpn-data Multi-arch: foreign (tracker.debian.org
    warning).
  * d/copyright: Remove unused GPL-2 license.

 -- Alec Leamas <leamas.alec@gmail.com>  Mon, 25 Apr 2022 22:44:41 +0200
