=== debian/changelog ===
opencpn (5.6.2+dfsg-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Initial buster  backport of 5.6.2+dfsg2.
  * Rebase and renumber patches.
  * Add 1.2M patch restoring bundled wxsvg library since system
    libwxsvg is not available on buster (handled by repacking in 5.6.0).

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 26 Apr 2022 18:11:07 +0200

opencpn (5.6.0+dfsg0-1~bpo10+2) buster-backports-sloppy; urgency=medium

  * Link to gtk2 instead of gtk3 to match available plugins.
    Closes: #1009701
  * Add upstream patches to make it possible to define the target as
    a compile time constant.
  * Add patch to avoid getting multiple possible plugins to load besides
    the Debian version.

 -- Alec Leamas <leamas.alec@gmail.com>  Wed, 13 Apr 2022 18:11:14 +0200

opencpn (5.6.0+dfsg0-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy.
  * Update VCS urls and gbp.conf default branch
  * Downgrade debhelper compat, 13 -> 12
  * Drop libwxsvg build dep
  * Don't strip libwxsvg in d/copyright, repack sources with bundled
    library in place. Use dfsg0 to make it precede dfsg1 in bullseye.

 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 30 Dec 2021 17:52:50 +0100
