=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg0|ds|deb)\.?\d*$//,\
filenamemangle=s/_(Release|Beta|Alpha|v|V)//;s|^.*tags/|opencpn-|;,\
uversionmangle=s/((Beta|Alpha|v|V|Release)[\.\-\+_]?)?//;,\
repacksuffix=+dfsg0 \
https://github.com/OpenCPN/OpenCPN/tags \
.*/(Beta|OA|v|V|Release)_([\d\.]+).zip
