## opencpn 5.8.4%2Bdfsg

=== libs/wxcurl/CMakeLists.txt ===
--- 
+++ 
@@ -46,12 +46,14 @@
 
 add_library(WXCURL STATIC ${SRC})
 add_library(ocpn::wxcurl ALIAS WXCURL)
-set_property(TARGET WXCURL PROPERTY COMPILE_FLAGS "-fvisibility=default")
+if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
+  set_property(TARGET WXCURL PROPERTY COMPILE_FLAGS "-fvisibility=default")
+endif ()
 target_include_directories(WXCURL
     PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
     PUBLIC ${CURL_INCLUDE_DIRS}
 )
-target_link_libraries(WXCURL ${CURL_LIBRARIES})
+target_link_libraries(WXCURL ${CURL_LIBRARIES})# ${wxWidgets_LIBRARIES})
 if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|AppleClang|GNU")
   target_compile_options(WXCURL  PRIVATE "-Wno-unknown-pragmas")
 endif ()
