=== debian/changelog ===
opencpn (5.8.4+dfsg-1~bpo11+1) bullseye-backports-sloppy; urgency=medium

  * New upstream-release
  * Rebuilt for bullseye-backports-sloppy.

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 21 Jul 2023 10:27:57 +0200

opencpn (5.8.2+dfsg-3) unstable; urgency=medium

  * d/rules: Try to fix test target on armhf et. al.

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 05 May 2023 15:45:02 +0200

opencpn (5.8.2+dfsg-2) unstable; urgency=medium

  * Add Depends: for jslib packages. Closes: #1034582.
  * opencpn uses wxWidgets 3.2 since 5.8.2+dfsg-1. Closes: #1019769

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 05 May 2023 15:11:38 +0200

opencpn (5.8.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Drop upstreamed patches

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 02 May 2023 17:23:43 +0200

opencpn (5.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Drop upstreamed patches, rebase remaining
  * Exclude MathJax and highlight js libraries, use packages instead.
  * Add new build deps:
     - libssl-dev
     - googletest
     - libglew-dev
     - repidjson-dev
     - libjs-highlight.js
     - libjs-mathjax
  * Update deprecated libpixbuf-dev build dep
  * Update d/copyright using cme.


 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 14 Apr 2023 09:37:20 +0200

opencpn (5.6.2+dfsg-2) unstable; urgency=medium

  * New bugfix release.
  * New patches, all applied upstream:
     - Fix upstream bug https://github.com/OpenCPN/OpenCPN/issues/2750
     - Handle tracking started before toolbar exists
     - Chart groups out of bounds access fix.
     - Allow GPX track point without time.
  * d/copyright: Remove more files when repackaging

 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 01 Sep 2022 14:33:43 +0200
