=== debian/control ===
--- 
+++ 
@@ -2,30 +2,39 @@
 Maintainer: Alec Leamas <leamas.alec@gmail.com>
 Section: misc
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  cmake,
+ googletest,
  libarchive-dev,
  libbz2-dev,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
+ libcxx-serial-dev,
  libdrm-dev,
  libelf-dev,
  libexif-dev,
- libgdk-pixbuf2.0-dev,
- libgtk2.0-dev,
+ libgdk-pixbuf-2.0-dev,
+ libglew-dev,
+ libgtk-3-dev,
+ libjs-highlight.js,
+ libjs-mathjax,
  liblz4-dev,
  liblzma-dev,
  libpango1.0-dev,
  libsqlite3-dev,
+ libssl-dev,
  libtinyxml-dev,
  libudev-dev,
  libunarr-dev,
  libusb-1.0-0-dev,
- libwxgtk3.0-dev,
+ libwxsvg-dev (>= 2:1.5.21),
+ libwxgtk3.2-dev | libwxgtk3.0-gtk3-dev,
+ libwxgtk-webview3.2-dev | libwxgtk-webview3.0-gtk3-dev,
  lsb-release,
- portaudio19-dev
+ portaudio19-dev,
+ rapidjson-dev
 Standards-Version: 4.6.0
 Vcs-Browser: https://gitlab.com/leamas/opencpn
-Vcs-Git: https://gitlab.com/leamas/opencpn.git -b debian/buster-sloppy
+Vcs-Git: https://gitlab.com/leamas/opencpn.git -b debian/sid
 Homepage: https://opencpn.org
 Rules-Requires-Root: no
 
@@ -33,6 +42,8 @@
 Architecture: any
 Depends: opencpn-data (>= ${source:Version}),
  bzip2,
+ libjs-mathjax,
+ libjs-highlight.js,
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends: wx3.0-i18n
@@ -52,6 +63,7 @@
 
 Package: opencpn-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Open Source Chartplotter and Marine GPS Navigation Software (data)
  Chart Plotter and Navigational software program for use underway
