=== debian/rules ===
#!/usr/bin/make -f

include  /usr/share/dpkg/architecture.mk

ifeq ($(DEB_TARGET_ARCH),amd64)
  TARGET_ARCH = x86_64
else
  TARGET_ARCH = $(DEB_TARGET_ARCH)
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=RelWithDebInfo \
            -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
            -DCMAKE_INSTALL_LIBDIR=/usr/lib \
            -DBUILD_SHARED_LIBS=OFF \
            -DOCPN_BUNDLE_DOCS=OFF \
            -DOCPN_BUNDLE_TCDATA=ON \
            -DOCPN_USE_BUNDLED_LIBS=OFF \
            -DOCPN_USE_NEWSERIAL=ON \
            -DOCPN_PLUGIN_CONTENTS_WARN=ON \
            -DOCPN_TARGET_TUPLE="debian-$(TARGET_ARCH);11;$(TARGET_ARCH)" \
	    -DOCPN_BUILD_TEST=OFF

override_dh_auto_test:
	cd obj-*-linux-gnu*; make run-tests
